Priority Queue for Running Simple Tasks
=======================================

Add tasks with a ‘due time’ to a queue, and retrieve the earliest.
It is intended to provide a simple Arduino ‘thread’ library
(very much in scare-quotes).

The software is Copyright 2016--2018, Norman Gray,
and is available under the terms of
[the 2-clause BSD licence](LICENCE.txt).
It is therefore perfectly happy to disappear into your source tree.

The code is available at [bitbucket](https://bitbucket.org/nxg/pqrst).


Installation and use
--------------------

Tasks are represented as subclasses of a `Task` class,
which implements a `run()` method.
The main loop of the program can end up as simple as

    while (1) {
        Queue.run_ready(millis());
    }

or even, within the Arduino framework,

    void loop(void)
    {
        Queue.run_ready(millis());
    }

To run the regression tests, do simply:

    % make check

To use the module, copy the files `pqrst.cpp` and `pqrst.h` into your source tree.
See the documentation and examples in the distributed `docs/` tree,
or the detailed class and function documentation at the
[project web page](https://nxg.me.uk/dist/pqrst/).


Norman Gray  
[https://nxg.me.uk](https://nxg.me.uk)
